// B25Decoder.cpp: CCB25Decoder NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "B25Decoder.h"


//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////

#pragma warning( disable : 4273 )

extern "C" __declspec(dllexport) IB25Decoder * CreateB25Decoder()
{
	// t@Ng\bh
	return (IB25Decoder *) new CB25Decoder;
}


// for Delphi
extern "C" {
__declspec(dllexport) const BOOL B25Decoder_Initialize(IB25Decoder *B25D, DWORD dwRound)
{
	return B25D->Initialize(dwRound);
}

__declspec(dllexport) void B25Decoder_Release(IB25Decoder *B25D)
{
	B25D->Release();
}

__declspec(dllexport) const BOOL B25Decoder_Decode(IB25Decoder *B25D, BYTE *pSrcBuf, const DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	return B25D->Decode(pSrcBuf,dwSrcSize,ppDstBuf,pdwDstSize);
}

__declspec(dllexport) const BOOL B25Decoder_Flush(IB25Decoder *B25D, BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	return B25D->Flush(ppDstBuf,pdwDstSize);
}

__declspec(dllexport) const BOOL B25Decoder_Reset(IB25Decoder *B25D)
{
	return B25D->Reset();
}
}

#pragma warning( default : 4273 )


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CB25Decoder::CB25Decoder()
	: m_TsPacketParser(NULL)
	, m_TsDescrambler(NULL)
	, m_MediaGrabber(NULL)
	, m_InputBuff(0x100000UL)	// 1MB̃obt@mۂ
	, m_OutputBuff(0x100000UL)	// 1MB̃obt@mۂ
{
	// fR[_Ot\z
	m_TsPacketParser.SetOutputDecoder(&m_TsDescrambler);
	m_TsDescrambler.SetOutputDecoder(&m_MediaGrabber);

	// ςTSpPbg󂯎R[obNo^
	m_MediaGrabber.SetMediaGrabCallback(CB25Decoder::OnPlainTsPacket, (PVOID)this);
}

CB25Decoder::~CB25Decoder()
{

}

const BOOL CB25Decoder::Initialize(DWORD dwRound)
{
	// B-CASJ[hI[vAfR[_OtZbg
	return Reset();
}

void CB25Decoder::Release()
{
	// CX^XJ
	delete this;
}

const BOOL CB25Decoder::Decode(BYTE *pSrcBuf, const DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!pSrcBuf || !pdwDstSize || !ppDstBuf || !pdwDstSize){
		// s
		return FALSE;
		}

	if(!m_TsDescrambler.GetBcasCardID(NULL)){
		// B-CASJ[hI[vĂȂ
		return FALSE;
		}

	// o̓obt@NA
	m_OutputBuff.ClearSize();

	// fBAf[^Zbg
	m_InputBuff.SetData(pSrcBuf, dwSrcSize);
	
	// fR[_ɓ͂
	if(!m_TsPacketParser.InputMedia(&m_InputBuff)){
		// fR[_OtŃG[
		return FALSE;
		}

	// o̓f[^Zbg
	*ppDstBuf = m_OutputBuff.GetData();
	*pdwDstSize = m_OutputBuff.GetSize();

	return TRUE;
}

const BOOL CB25Decoder::Flush(BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!ppDstBuf || !pdwDstSize){
		// s
		return FALSE;
		}

	// o̓f[^Zbg(f[^͎cȂߏɋ)
	*ppDstBuf = NULL;
	*pdwDstSize = 0;

	return TRUE;
}

const BOOL CB25Decoder::Reset(void)
{
	// B-CASJ[hăI[v
	if(!m_TsDescrambler.OpenBcasCard())return FALSE;

	// o̓obt@NA
	m_OutputBuff.ClearSize();

	// fR[_OtZbg
	m_TsPacketParser.Reset();

	return TRUE;
}

void CALLBACK CB25Decoder::OnPlainTsPacket(const CMediaData *pMediaData, const PVOID pParam)
{
	CB25Decoder *pThis = static_cast<CB25Decoder *>(pParam);

	// TSpPbg󂯎R[obN
	pThis->m_OutputBuff.AddData(pMediaData);
}
