// IB25Decoder.h: IB25Decoder NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_IB25DECORDER_H_)
#define _IB25DECORDER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// B25fR[_C^tF[X
class IB25Decoder
{
public:
	virtual const BOOL Initialize(DWORD dwRound = 4) = 0;
	virtual void Release(void) = 0;

	virtual const BOOL Decode(BYTE *pSrcBuf, const DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize) = 0;
	virtual const BOOL Flush(BYTE **ppDstBuf, DWORD *pdwDstSize) = 0;
	virtual const BOOL Reset(void) = 0;
};


// CX^X\bh
extern "C" __declspec(dllimport) IB25Decoder * CreateB25Decoder(void);

// for Delphi
extern "C" {
	__declspec(dllexport) const BOOL B25Decoder_Initialize(IB25Decoder *B25D, DWORD dwRound);
	__declspec(dllexport) void B25Decoder_Release(IB25Decoder *B25D);
	__declspec(dllexport) const BOOL B25Decoder_Decode(IB25Decoder *B25D, BYTE *pSrcBuf, const DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize);
	__declspec(dllexport) const BOOL B25Decoder_Flush(IB25Decoder *B25D, BYTE **ppDstBuf, DWORD *pdwDstSize);
	__declspec(dllexport) const BOOL B25Decoder_Reset(IB25Decoder *B25D);
}

#endif // !defined(_IB25DECORDER_H_)
