unit pLogUtils;

interface

const
  ALL     = 255;
  DEBUG   = 128;
  INFO    = 64;
  WARNING = 32;
  ERROR   = 16;
  NONE    = 0;

type
  TLogCallback = procedure(AText: String) of Object;

  TLogUtil = class(TObject)
    constructor Create;
  private
    FLogCallback: TLogCallback;
    FLogLevel   : Integer;
  public
    procedure Log(Level:Integer; Module,AText:String);
    procedure Dbg(AText:String);
    property  LogCallback: TLogCallback read FLogCallback  write FLogCallback;
    property  Level: Integer read FLogLevel  write FLogLevel;
  end;

implementation

constructor TLogUtil.Create;
begin
  FLogLevel := ALL;
end;

procedure TLogUtil.Log(Level:Integer; Module,AText:String);
begin
  if Assigned(FLogCallback) then
  begin
    if (FLogLevel>=Level) then FLogCallback('['+Module+']'+AText);
  end;
end;

procedure TLogUtil.Dbg(AText:String);
begin
  Log(DEBUG,'Debug',AText);
end;

end.
